package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.TouchEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesCustomGesture extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var drawArea:Shape;
		private var trackBeginObject:Object;
		
		public function MobileAS3ExamplesCustomGesture() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupDrawArea();
			setupTouchEvents();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 30;
			traceFormat.align = "left";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupDrawArea():void {
			drawArea = new Shape();
			addChild(drawArea);
		}
		
		protected function setupTouchEvents():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			trackBeginObject = new Object();
			stage.addEventListener(TouchEvent.TOUCH_BEGIN, touchBegin);
			stage.addEventListener(TouchEvent.TOUCH_MOVE, touchMove);
			stage.addEventListener(TouchEvent.TOUCH_END, touchEnd);
		}
		
		protected function touchBegin(e:TouchEvent):void {
			if(e.isPrimaryTouchPoint){
				drawArea.graphics.clear();
				drawArea.graphics.lineStyle(20, 0xFFFFFF, 0.8);
				trackBeginObject.x = e.stageX;
				trackBeginObject.y = e.stageY;
				drawArea.graphics.moveTo(e.stageX, e.stageY);
			}
		}
		
		protected function touchMove(e:TouchEvent):void {
			if(e.isPrimaryTouchPoint){
				drawArea.graphics.lineTo(e.stageX, e.stageY);
			}
		}
		
		protected function touchEnd(e:TouchEvent):void {
			if(e.isPrimaryTouchPoint){
				if(e.stageX > trackBeginObject.x && e.stageY > trackBeginObject.y){
					traceField.text = "Diagonal Gesture: TL -> BR";
				}else if(e.stageX < trackBeginObject.x && e.stageY > trackBeginObject.y){
					traceField.text = "Diagonal Gesture: TR -> BL";
				}else if(e.stageX < trackBeginObject.x && e.stageY < trackBeginObject.y){
					traceField.text = "Diagonal Gesture: BR -> TL";
				}else if(e.stageX > trackBeginObject.x && e.stageY < trackBeginObject.y){
					traceField.text = "Diagonal Gesture: BL -> TR";
				}
			}
		}
		
	}
}
