package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Keyboard;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesDpad extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var box:Shape;
		
		public function MobileAS3ExamplesDpad() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupBox();
			registerListeners();
		}
		
		protected function setupBox():void {
			box = new Shape();
			box.graphics.beginFill(0xFFFFFF, 1);
			box.x = stage.stageWidth/2;
			box.y = stage.stageHeight/2;
			box.graphics.drawRect(-100,-100,200,200);
			box.graphics.endFill();
			addChild(box);
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDown);
		}
		
		protected function keyDown(e:KeyboardEvent):void {
			var key:uint = e.keyCode;
			traceField.text = key + " pressed!";
			switch(key){
				case Keyboard.UP:{
					box.y -= 20;
					break;
				}
				case Keyboard.DOWN:{
					box.y += 20;
					break;
				}
				case Keyboard.LEFT:{
					box.x -= 20;
					break;
				}
				case Keyboard.RIGHT:{
					box.x += 20;
					break;
				}
				case Keyboard.ENTER:{
					box.x = stage.stageWidth/2;
					box.y = stage.stageHeight/2;
					break;
				}
			}
		}
		
	}
}
