package {
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.display.Stage;
	import flash.display.Sprite;
	import flash.events.TimerEvent;
	import flash.events.TouchEvent;
	import flash.geom.Rectangle;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import flash.utils.Timer;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesLongPress extends Sprite {
		
		private var box:Sprite;
		private var lpTimer:Timer;
		
		public function MobileAS3ExamplesLongPress() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTimer();
			setupBox();
			setupTouchEvents();
		}
		
protected function setupTimer():void {
lpTimer = new Timer(1000,1);
			lpTimer.addEventListener(TimerEvent.TIMER_COMPLETE, timerEnd);
}

		protected function setupBox():void {
			box = new Sprite();
			box.graphics.beginFill(0xFFFFFF, 1);
			box.x = stage.stageWidth/2;
			box.y = stage.stageHeight/2;
			box.graphics.drawRect(-100,-100,200,200);
			box.graphics.endFill();
			addChild(box);
		}
		
		protected function setupTouchEvents():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			box.addEventListener(TouchEvent.TOUCH_BEGIN, touchBegin);
			box.addEventListener(TouchEvent.TOUCH_END, touchEnd);
			box.addEventListener(TouchEvent.TOUCH_OUT, touchEnd);
			box.addEventListener(TouchEvent.TOUCH_ROLL_OUT, touchEnd);
		}
		
		protected function touchBegin(e:TouchEvent):void {
			box.scaleX += 0.1;
			box.scaleY += 0.1;
			box.alpha = 0.8;
			lpTimer.start();
		}
		
		protected function timerEnd(e:TimerEvent):void {
			var dragBounds:Rectangle = new Rectangle(box.width/2, box.height/2, stage.stageWidth-box.width, stage.stageHeight-box.height);
			box.startDrag(true, dragBounds);
		}
		
		protected function touchEnd(e:TouchEvent):void {
			lpTimer.stop();
			box.stopDrag();
			box.scaleX = 1;
			box.scaleY = 1;
			box.alpha = 1;
		}
		
	}
}
