package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.SoftKeyboardEvent;
	import flash.events.TouchEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesToggleKeyboard extends Sprite {
		
		private var tapBox:Sprite;
		private var tapBoxField:TextField;
		private var tapBoxFormat:TextFormat;
		
		public function MobileAS3ExamplesToggleKeyboard() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupBox();
			setupTouchEvents();
		}
		
		protected function setupBox():void {
			tapBox = new Sprite();
			tapBox.graphics.beginFill(0xFFFFFF, 1);
			tapBox.x = stage.stageWidth/2;
			tapBox.y = stage.stageHeight/2 - 200;
			tapBox.graphics.drawRect(-200,-100,400,160);
			tapBox.graphics.endFill();
			
			tapBoxFormat = new TextFormat;
			tapBoxFormat.bold = true;
			tapBoxFormat.font = "_sans";
			tapBoxFormat.size = 42;
			tapBoxFormat.align = "center";
			tapBoxFormat.color = 0x333333;
			
			tapBoxField = new TextField();
			tapBoxField.defaultTextFormat = tapBoxFormat;
			tapBoxField.selectable = false;
			tapBoxField.mouseEnabled = false;
			tapBoxField.multiline = true;
			tapBoxField.wordWrap = true;
			tapBoxField.width = tapBox.width;
			tapBoxField.height = tapBox.height;
			tapBoxField.x = -200;
			tapBoxField.y = -80;
			tapBoxField.text = "Tap to Toggle Virtual Keyboard";
			
			tapBox.addChild(tapBoxField);
			addChild(tapBox);
		}
		
		protected function setupTouchEvents():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			
			tapBox.needsSoftKeyboard = true;
			tapBox.addEventListener(TouchEvent.TOUCH_TAP, touchTap);
						tapBox.addEventListener(SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATING, vkActivating);
			tapBox.addEventListener(SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATE, vkActivate);
			tapBox.addEventListener(SoftKeyboardEvent.SOFT_KEYBOARD_DEACTIVATE, vkDeactivate);
		}
		
		protected function touchTap(e:TouchEvent):void {
			if(tapBox.needsSoftKeyboard == true){
				tapBox.requestSoftKeyboard();
				tapBoxField.text = "Virtual Keyboard is Up";
				tapBox.needsSoftKeyboard = false;
			}else{
				tapBox.needsSoftKeyboard = true;
				tapBoxField.text = "Virtual Keyboard is Down";
			}
		}
		
		protected function vkActivating(e:SoftKeyboardEvent):void {
			trace("Virtual Keyboard ACTIVATING");
		}
		
		protected function vkActivate(e:SoftKeyboardEvent):void {
			trace("Virtual Keyboard ACTIVATED");
		}
		
		protected function vkDeactivate(e:SoftKeyboardEvent):void {
			trace("Virtual Keyboard DEACTIVATED");
		}
		
	}
}
