package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.AccelerometerEvent;
	import flash.sensors.Accelerometer;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesAccelerometerBox extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var box:Shape;
		private var accelerometer:Accelerometer;
		
		public function MobileAS3ExamplesAccelerometerBox() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupBox();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupBox():void {
			box = new Shape();
			box.graphics.beginFill(0xFFFFFF, 1);
			box.x = stage.stageWidth/2;
			box.y = stage.stageHeight/2;
			box.graphics.drawRect(-100,-100,200,200);
			box.graphics.endFill();
			addChild(box);
		}
		
		protected function registerListeners():void {
			accelerometer = new Accelerometer();
			
			accelerometer.addEventListener(AccelerometerEvent.UPDATE, movementDetected);
		}
		
		protected function movementDetected(e:AccelerometerEvent):void {
			traceField.text = "";
			
			var speed:Number = 20;
			if(box.x > box.width/2){
				box.x -= Math.floor(e.accelerationX*speed);
			}else{
				box.x = box.width/2;
			}
			if(box.x < stage.stageWidth-(box.width/2)){
				box.x -= Math.floor(e.accelerationX*speed);
			}else{
				box.x = stage.stageWidth-(box.width/2);
			}
			if(box.y > box.height/2){
				box.y += Math.floor(e.accelerationY*speed);
			}else{
				box.y = box.height/2;
			}
			if(box.y < stage.stageHeight-(box.height/2)){
				box.y += Math.floor(e.accelerationY*speed);
			}else{
				box.y = stage.stageHeight-(box.height/2);
			}
			
			traceField.appendText("box.x: " + box.x + "\n");
			traceField.appendText("box.y: " + box.y + "\n");
		}
		
	}
}
