package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.AccelerometerEvent;
	import flash.events.TouchEvent;
	import flash.sensors.Accelerometer;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesAccelerometerInterval extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var accelerometer:Accelerometer;
		private var accelerometerInterval:Number;
		private var boxUp:Sprite;
		private var boxDown:Sprite;
		
		public function MobileAS3ExamplesAccelerometerInterval() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupBoxes();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupBoxes():void {
			boxUp = new Sprite();
			boxUp.name = "boxUp";
			boxUp.graphics.beginFill(0xFFFFFF, 1);
			boxUp.x = 20;
			boxUp.y = stage.stageHeight/2;
			boxUp.graphics.drawRect(0,0,100,80);
			boxUp.graphics.endFill();
			addChild(boxUp);
			
			boxDown = new Sprite();
			boxDown.name = "boxDown";
			boxDown.graphics.beginFill(0xFFFFFF, 1);
			boxDown.x = stage.stageWidth - 120;
			boxDown.y = stage.stageHeight/2;
			boxDown.graphics.drawRect(0,0,100,80);
			boxDown.graphics.endFill();
			addChild(boxDown);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			
			boxUp.addEventListener(TouchEvent.TOUCH_TAP, shiftInterval);
			boxDown.addEventListener(TouchEvent.TOUCH_TAP, shiftInterval);
			
			accelerometer = new Accelerometer();
			accelerometerInterval = 100;
			accelerometer.setRequestedUpdateInterval(accelerometerInterval);
			accelerometer.addEventListener(AccelerometerEvent.UPDATE, movementDetected);
		}
		
		protected function shiftInterval(e:TouchEvent):void {
			switch(e.target.name){
				case "boxUp":{
					accelerometerInterval += 100;
					break;
				}
				case "boxDown":{
					accelerometerInterval -= 100;
					break;
				}
			}
			if(accelerometerInterval < 0){
				accelerometerInterval = 0;
			}
			accelerometer.setRequestedUpdateInterval(accelerometerInterval);
		}
		
		protected function movementDetected(e:AccelerometerEvent):void {
			traceField.text = "Interval: " + accelerometerInterval + "\n\n";
			traceField.appendText("Time: " + e.timestamp + "\n");
			traceField.appendText("X: " + e.accelerationX + "\n");
			traceField.appendText("Y: " + e.accelerationY + "\n");
			traceField.appendText("Z: " + e.accelerationZ + "\n");
		}
		
	}
}
