package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.AccelerometerEvent;
	import flash.sensors.Accelerometer;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesAccelerometerTilt extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var accelerometer:Accelerometer;
		
		public function MobileAS3ExamplesAccelerometerTilt() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			accelerometer = new Accelerometer();
			
			accelerometer.addEventListener(AccelerometerEvent.UPDATE, movementDetected);
		}
		
		protected function movementDetected(e:AccelerometerEvent):void {
			traceField.text = "";
			traceField.appendText("Time: " + e.timestamp + "\n");
			traceField.appendText("X: " + e.accelerationX + "\n");
			traceField.appendText("Y: " + e.accelerationY + "\n");
			traceField.appendText("Z: " + e.accelerationZ + "\n");
			if(e.accelerationY > 0.5){
				traceField.appendText("\n\n\nPORTRAIT");
			}else{
				traceField.appendText("\n\n\nLANDSCAPE");
			}
		}
		
	}
}
