package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.GeolocationEvent;
	import flash.sensors.Geolocation;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesGeoUpdate extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var geolocation:Geolocation;
		
		public function MobileAS3ExamplesGeoUpdate() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			geolocation = new Geolocation();
			geolocation.addEventListener(GeolocationEvent.UPDATE, geolocationUpdate);
		}
		
		protected function geolocationUpdate(e:GeolocationEvent):void {
			traceField.text = "";
			traceField.appendText("altitude: " + e.altitude + "\n");
			traceField.appendText("heading: " + e.heading + "\n");
			traceField.appendText("horizontal accuracy: " + e.horizontalAccuracy + "\n");
			traceField.appendText("latitude: " + e.latitude + "\n");
			traceField.appendText("longitude: " + e.longitude + "\n");
			traceField.appendText("speed: " + e.speed + "\n");
			traceField.appendText("timestamp: " + e.timestamp + "\n");
			traceField.appendText("vertical accuracy: " + e.verticalAccuracy);	
		}
		
	}
}
