package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.GeolocationEvent;
	import flash.events.TouchEvent;
	import flash.sensors.Geolocation;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesGeolocationInterval extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var geolocation:Geolocation;
		private var geolocationInterval:Number;
		private var boxUp:Sprite;
		private var boxDown:Sprite;
		
		public function MobileAS3ExamplesGeolocationInterval() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupBoxes();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupBoxes():void {
			boxUp = new Sprite();
			boxUp.name = "boxUp";
			boxUp.graphics.beginFill(0xFFFFFF, 0.6);
			boxUp.x = 20;
			boxUp.y = stage.stageHeight/2;
			boxUp.graphics.drawRect(0,0,100,80);
			boxUp.graphics.endFill();
			addChild(boxUp);
			
			boxDown = new Sprite();
			boxDown.name = "boxDown";
			boxDown.graphics.beginFill(0xFFFFFF, 0.6);
			boxDown.x = stage.stageWidth - 120;
			boxDown.y = stage.stageHeight/2;
			boxDown.graphics.drawRect(0,0,100,80);
			boxDown.graphics.endFill();
			addChild(boxDown);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			
			boxUp.addEventListener(TouchEvent.TOUCH_TAP, shiftInterval);
			boxDown.addEventListener(TouchEvent.TOUCH_TAP, shiftInterval);
			
			geolocation = new Geolocation();
			geolocationInterval = 100;
			geolocation.setRequestedUpdateInterval(geolocationInterval);
			geolocation.addEventListener(GeolocationEvent.UPDATE, geolocationUpdate);
		}
		
		protected function shiftInterval(e:TouchEvent):void {
			switch(e.target.name){
				case "boxUp":{
					geolocationInterval += 100;
					break;
				}
				case "boxDown":{
					geolocationInterval -= 100;
					break;
				}
			}
			if(geolocationInterval < 0){
				geolocationInterval = 0;
			}
			geolocation.setRequestedUpdateInterval(geolocationInterval);
		}
		
		protected function geolocationUpdate(e:GeolocationEvent):void {
			traceField.text = "Interval: " + geolocationInterval + "\n\n";
			traceField.appendText("altitude: " + e.altitude + "\n");
			traceField.appendText("heading: " + e.heading + "\n");
			traceField.appendText("horizontal accuracy: " + e.horizontalAccuracy + "\n");
			traceField.appendText("latitude: " + e.latitude + "\n");
			traceField.appendText("longitude: " + e.longitude + "\n");
			traceField.appendText("speed: " + e.speed + "\n");
			traceField.appendText("timestamp: " + e.timestamp + "\n");
			traceField.appendText("vertical accuracy: " + e.verticalAccuracy);	
		}
		
	}
}
