package {
	import com.google.maps.LatLng;
	import com.google.maps.Map;
	import com.google.maps.MapEvent;
	import com.google.maps.MapType;
	import com.google.maps.overlays.Marker;
	
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.GeolocationEvent;
	import flash.geom.Point;
	import flash.sensors.Geolocation;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesGeolocationMap extends Sprite {
		
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var geolocation:Geolocation;
		private var map:Map;
		private var coordinates:LatLng;
		
		public function MobileAS3ExamplesGeolocationMap() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupMap();
			setupTextField();
			registerListeners();
		}
		
		protected function setupMap():void {
			map = new Map();
			map.key = "{GOOGLE_MAPS_API_KEY}";
			map.url = "{APP_URL}";
			map.sensor = "true";
			map.setSize(new Point(stage.stageWidth, stage.stageHeight));
			addChild(map);
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			geolocation = new Geolocation();
			geolocation.addEventListener(GeolocationEvent.UPDATE, geolocationUpdate);
			map.addEventListener(MapEvent.MAP_READY, mapReady);
		}
		
		protected function mapReady(e:MapEvent):void {
			map.setCenter(coordinates, 16, MapType.NORMAL_MAP_TYPE);
			var marker:Marker = new Marker(map.getCenter());
			map.addOverlay(marker);
		}
		
		protected function geolocationUpdate(e:GeolocationEvent):void {
			traceField.text = "";
			traceField.appendText("latitude:\n" + e.latitude + "\n\n");
			traceField.appendText("longitude:\n" + e.longitude);
			coordinates = new LatLng(e.latitude, e.longitude);
		}
		
	}
}
