package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.SampleDataEvent;
	import flash.events.TouchEvent;
	import flash.media.Microphone;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.utils.ByteArray;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesAudio extends Sprite {
		
		private var mic:Microphone;
		private var micRec:ByteArray;
		private var output:Sound;
		private var outputChannel:SoundChannel;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesAudio() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupMic();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupMic():void {
			mic = Microphone.getMicrophone();
			mic.setSilenceLevel(0);
			mic.rate = 44;
			mic.setLoopBack(false);
			micRec = new ByteArray();
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			stage.addEventListener(TouchEvent.TOUCH_TAP, startRecording);
			traceField.text = "Tap to Record";
		}
		
		protected function startRecording(e:TouchEvent):void {
			stage.removeEventListener(TouchEvent.TOUCH_TAP, startRecording);
			stage.addEventListener(TouchEvent.TOUCH_TAP, stopRecording);
			mic.addEventListener(SampleDataEvent.SAMPLE_DATA, onMicData);
			traceField.text = "Recording Audio\nTap to Stop";
		}
		
		protected function onMicData(e:SampleDataEvent):void {
			micRec.writeBytes(e.data);
		}
		
		protected function stopRecording(e:TouchEvent):void {
			mic.removeEventListener(SampleDataEvent.SAMPLE_DATA, onMicData);
			stage.removeEventListener(TouchEvent.TOUCH_TAP, stopRecording);
			stage.addEventListener(TouchEvent.TOUCH_TAP, playBackAudio);
			traceField.text = "Tap to Playback";
		}
		
		protected function playBackAudio(e:TouchEvent):void {
			stage.removeEventListener(TouchEvent.TOUCH_TAP, playBackAudio);
			micRec.position = 0;
			output = new Sound();
			output.addEventListener(SampleDataEvent.SAMPLE_DATA, onSampleDataRequest);
			outputChannel = output.play();
			traceField.text = "Playing Audio";
		}
		
		protected function onSampleDataRequest(e:SampleDataEvent):void {
			var out:ByteArray = new ByteArray();
			for( var i:int = 0 ; i < 8192 && micRec.bytesAvailable; i++ ) {
				var micsamp:Number = micRec.readFloat();
				out.writeFloat(micsamp);
				out.writeFloat(micsamp);
			}
			e.data.writeBytes(out);
		}
		
	}
	
}
