package {
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.TouchEvent;
	import flash.media.Camera;
	import flash.media.CameraRoll;
	import flash.media.Video;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesCamera extends Sprite {
		
		private var video:Video;
		private var videoHolder:Sprite;
		private var camera:Camera;
		private var capture:BitmapData;
		private var cameraRoll:CameraRoll;
		
		public function MobileAS3ExamplesCamera() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupVideo();
			setupCamera();
			registerListeners();
		}
		
		protected function setupVideo():void {
			videoHolder = new Sprite();
			videoHolder.x = stage.stageWidth/2;
			videoHolder.y = stage.stageHeight/2;
			video = new Video(360, 480);
			videoHolder.addChild(video);
			video.x = -180;
			video.y = -240;
			videoHolder.rotation = 90;
			addChild(videoHolder);
		}
		
		protected function setupCamera():void {
			camera = Camera.getCamera();
			camera.setMode(480, 360, 24);
			video.attachCamera(camera);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			stage.addEventListener(TouchEvent.TOUCH_TAP, saveImage);
		}
		
		protected function saveImage(e:TouchEvent):void {
			capture = new BitmapData(360, 480);
			capture.draw(video);
			cameraRoll = new CameraRoll();
			cameraRoll.addBitmapData(capture);
		}
		
	}
	
} 
