package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MediaEvent;
	import flash.events.TouchEvent;
	import flash.media.CameraUI;
	import flash.media.MediaPromise;
	import flash.media.MediaType;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesCameraUIVideo extends Sprite {
		
		private var camera:CameraUI;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesCameraUIVideo() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupCamera();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 34;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupCamera():void {
			camera = new CameraUI();
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			camera.addEventListener(MediaEvent.COMPLETE, videoReady);
			stage.addEventListener(TouchEvent.TOUCH_TAP, launchCamera);
		}
		
		protected function launchCamera(e:TouchEvent):void {
			camera.launch(MediaType.VIDEO);
		}
		
		protected function videoReady(e:MediaEvent):void {
			var promise:MediaPromise = e.data;
			traceField.appendText("mediaType: " + promise.mediaType + "\n");
			traceField.appendText("relativePath: " + promise.relativePath + "\n");
			traceField.appendText("creationDate: " + promise.file.creationDate + "\n");
			traceField.appendText("extension: " + promise.file.extension + "\n");
			traceField.appendText("name: " + promise.file.name + "\n");
			traceField.appendText("size: " + promise.file.size + "\n");
			traceField.appendText("type: " + promise.file.type + "\n");
			traceField.appendText("nativePath: " + promise.file.nativePath + "\n");
			traceField.appendText("url: " + promise.file.url + "\n");
		}
		
	}
	
}
