package {
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.SampleDataEvent;
	import flash.media.Microphone;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesMicrophone extends Sprite {
		
		private var mic:Microphone;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesMicrophone() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupMic();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x333333;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupMic():void {
			mic = Microphone.getMicrophone();
			mic.setSilenceLevel(0);
			mic.rate = 44;
			mic.setLoopBack(false);
		}
		
		protected function registerListeners():void {
			mic.addEventListener(SampleDataEvent.SAMPLE_DATA, onMicData);
		}
		
		public function onMicData(e:SampleDataEvent):void {
			traceField.text = "";
			traceField.appendText("activityLevel: " + e.target.activityLevel + "\n");
			traceField.appendText("codec: " + e.target.codec + "\n");
			traceField.appendText("gain: " + e.target.gain + "\n");
			traceField.appendText("bytesAvailable: " + e.data.bytesAvailable + "\n");
			traceField.appendText("length: " + e.data.length + "\n");
			traceField.appendText("position: " + e.data.position + "\n");
		}
		
	}
	
}
