package {
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MediaEvent;
	import flash.events.TouchEvent;
	import flash.filesystem.File;
	import flash.media.CameraRoll;
	import flash.media.MediaPromise;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesCameraRoll extends Sprite {
		
		private var loader:Loader;
		private var cameraRoll:CameraRoll;
		
		public function MobileAS3ExamplesCameraRoll() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupLoader();
			setupCameraRoll();
			registerListeners();
		}
		
		protected function setupLoader():void {
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, sizePhoto);
			stage.addChild(loader);
		}
		
		protected function setupCameraRoll():void {
			cameraRoll = new CameraRoll();
			cameraRoll.addEventListener(MediaEvent.SELECT, imageSelected);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			stage.addEventListener(TouchEvent.TOUCH_TAP, loadFromCameraRoll);
		}
		
		protected function loadFromCameraRoll(e:TouchEvent):void {
			cameraRoll.browseForImage();
		}
		
		protected function imageSelected(e:MediaEvent):void {
			var promise:MediaPromise = e.data;
			loader.loadFilePromise(promise);
			trace(e.data.file);
			trace(e.data.mediaType);
			trace(e.data.relativePath);
		}
		
		protected function sizePhoto(e:Event):void {
			loader.width = stage.stageWidth;
			loader.scaleY = loader.scaleX;
		}
		
	}
}
