package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.SampleDataEvent;
	import flash.events.TouchEvent;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import flash.utils.ByteArray;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesGenerate extends Sprite {
		
		private var sound:Sound;
		private var channel:SoundChannel;
		private var touchPressure:Number;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesGenerate() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupSound();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "center";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupSound():void {
			sound = new Sound();
			channel = new SoundChannel();
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			stage.addEventListener(TouchEvent.TOUCH_BEGIN, onTouch);
			sound.addEventListener(SampleDataEvent.SAMPLE_DATA, onSampleDataRequest);
			channel = sound.play();
		}
		
		protected function onTouch(e:TouchEvent):void {
			touchPressure = e.pressure;
			traceField.text = "Pressure: " + touchPressure;
		}
		
		protected function onSampleDataRequest(e:SampleDataEvent):void {
			var out:ByteArray = new ByteArray();
			for( var i:int = 0 ; i < 8192; i++ ) {
				out.writeFloat(Math.sin((Number(i+e.position)/Math.PI/2))*touchPressure);
				out.writeFloat(Math.sin((Number(i+e.position)/Math.PI/2))*touchPressure);
			}
			e.data.writeBytes(out);
		}
		
	}
}
