package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.NetStatusEvent;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesHTTPVideo extends Sprite {
		
		private const videoPath:String = "assets/test.m4v";
		private var video:Video;
		private var streamClient:Object;
		private var connection:NetConnection;
		private var stream:NetStream;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesHTTPVideo() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupVideoConnection();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "center";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupVideoConnection():void {
			streamClient = new Object();
			streamClient.onTextData = onTextData;
			streamClient.onMetaData = onMetaData;
			streamClient.onCuePoint = onCuePoint;
			
			video = new Video();
			video.smoothing = true;
			addChild(video);
			
			connection = new NetConnection();
			connection.client = streamClient;
			connection.addEventListener(NetStatusEvent.NET_STATUS, onNetStatus);
			connection.connect(null);
		}
		
		protected function connectStream():void {
			stream = new NetStream(connection);
			stream.addEventListener(NetStatusEvent.NET_STATUS, onNetStatus);
			stream.client = streamClient;
			
			video.attachNetStream(stream);
			stream.play(videoPath);
		}
		
		protected function onNetStatus(e:NetStatusEvent):void {
			traceField.appendText(e.info.code + "\n");
			switch (e.info.code) {
				case "NetConnection.Connect.Success":
					connectStream();
					break;
				case "NetStream.Buffer.Full":
					video.width = stage.stageWidth;
					video.scaleY = video.scaleX;
					traceField.y = video.height;
					break;
			}
		}
		
		public function onTextData(info:Object):void {
			traceField.appendText("Text!\n");
		}
		public function onMetaData(info:Object):void {
			traceField.appendText("Duration: " + info.duration + "\n");
			traceField.appendText("Width: " + info.width + "\n");
			traceField.appendText("Height: " + info.height + "\n");
			traceField.appendText("Codec: " + info.videocodecid + "\n");
			traceField.appendText("FPS: " + info.videoframerate + "\n");
		}
		public function onCuePoint(info:Object):void {
			traceField.appendText("Cuepoint!\n");
		}
		
	}
}
