package {
	import flash.display.Loader;
	import flash.display.Shader;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.TouchEvent;
	import flash.filters.ShaderFilter;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	
	/*
	Referenced Pixel Bender filters are available from the Adobe Exchange:
	
	namespace : "Dot";
	vendor : "Shogo Kimura";
	version : 1;
	
	namespace : "LineSlide";
	vendor : "Shogo Kimura";
	version : 1;
	
	namespace : "outline";
	vendor : "Shogo Kimura";
	version : 1;
	
	*/
	
	public class MobileAS3ExamplesPixelBender extends Sprite {
		
		private const photoURL:String = "file:///mnt/sdcard/dropbox/20100623_085909.jpg";
		private var loader:Loader;
		private var urlRequest:URLRequest;
		private var urlLoader:URLLoader;
		private var pbjArray:Array;
		private var currentFilter:int;
		private var shader:Shader;
		private var shaderFilter:ShaderFilter;
		
		public function MobileAS3ExamplesPixelBender() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupArray();
			setupLoader();
			registerListeners();
			loadPhotograph();
		}
		
		protected function setupArray():void {
			pbjArray = new Array();
			pbjArray[0] = "dot.pbj";
			pbjArray[1] = "LineSlide.pbj";
			pbjArray[2] = "outline.pbj";
		}
		
		protected function setupLoader():void {
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, sizePhoto);
			stage.addChild(loader);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			loader.addEventListener(TouchEvent.TOUCH_TAP, loadShader);
			currentFilter = 0;
		}
		
		protected function loadPhotograph():void {
			loader.load(new URLRequest(photoURL));
		}
		
		protected function sizePhoto(e:Event):void {
			loader.width = stage.stageWidth;
			loader.scaleY = loader.scaleX;
		}
		
		protected function loadShader(e:TouchEvent):void {
			urlRequest = new URLRequest(pbjArray[currentFilter]);
			urlLoader = new URLLoader();
			urlLoader.dataFormat = URLLoaderDataFormat.BINARY;
			urlLoader.addEventListener(Event.COMPLETE, applyFilter);
			urlLoader.load(urlRequest);
			if(currentFilter < pbjArray.length-1){
				currentFilter++;
			}else{
				currentFilter = 0;
			}
		}
		
		protected function applyFilter(e:Event):void {
			shader = new Shader(e.target.data);
			shaderFilter = new ShaderFilter(shader);
			loader.filters = [shaderFilter];
		}
		
	}
}
