package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.TransformGestureEvent;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesSound extends Sprite {
		
		private var sound:Sound;
		private var channel:SoundChannel;
		private var sTransform:SoundTransform;
		private var dial:Sprite;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesSound() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupDial();
			setupSound();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "center";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.mouseEnabled = false;
			traceField.width = stage.stageWidth;
			traceField.height = stage.stageHeight;
			addChild(traceField);
		}
		
		protected function setupDial():void {
			dial = new Sprite();
			dial.graphics.beginFill(0xFFFFFF, 1);
			dial.x = stage.stageWidth/2;
			dial.y = stage.stageHeight/2;
			dial.graphics.drawCircle(0,0,150);
			dial.graphics.endFill();
			dial.graphics.lineStyle(5,0x440000);
			dial.graphics.moveTo(0, -150);
			dial.graphics.lineTo(0, 0);
			addChild(dial);
		}
		
		protected function setupSound():void {
			sound = new Sound();
			sound.load(new URLRequest("assets/test.mp3"));
			
			sTransform = new SoundTransform(0.5, 0);
			
			channel = new SoundChannel();
			channel.soundTransform = sTransform;
			channel = sound.play();
			
			traceField.text = "Volume: " + sTransform.volume;
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			dial.addEventListener(TransformGestureEvent.GESTURE_ROTATE, onRotate);
		}
		
		protected function onRotate(e:TransformGestureEvent):void {
			dial.rotation += e.rotation;
			sTransform.volume = (dial.rotation+180)/360;
			channel.soundTransform = sTransform;
			traceField.text = "Volume: " + sTransform.volume;
		}
		
	}
}
