package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.TimerEvent;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundMixer;
	import flash.net.URLRequest;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import flash.utils.ByteArray;
	import flash.utils.Timer;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesSpectrum extends Sprite {
		
		private var sound:Sound;
		private var channel:SoundChannel;
		private var spectrum:Sprite;
		private var timer:Timer;
		
		public function MobileAS3ExamplesSpectrum() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupSpectrum();
			registerTimer();
			setupSound();
		}
		
		protected function setupSpectrum():void {
			spectrum = new Sprite();
			spectrum.graphics.lineStyle(5, 0xFFFFFF);
			addChild(spectrum);
		}
		
		protected function registerTimer():void {
			timer = new Timer(100);
			timer.addEventListener(TimerEvent.TIMER, onTimer);
		}
		
		protected function setupSound():void {
			sound = new Sound();
			sound.load(new URLRequest("assets/test.mp3"));
			
			channel = new SoundChannel();
			channel = sound.play();
			
			timer.start();
		}
		
		protected function onTimer(e:TimerEvent):void {
			var a:Number = 0;
			var n:Number = 0;
			var i:int = 0;
			var ba:ByteArray = new ByteArray();
			SoundMixer.computeSpectrum(ba);
			spectrum.graphics.clear();
			spectrum.graphics.lineStyle(4, 0xFFFFFF, 0.8, false);
			spectrum.graphics.moveTo(0, (n/2)+150);
			for(i=0; i<=256; i++) {
				a = ba.readFloat();
				n = a*300;
				spectrum.graphics.lineTo(i*(stage.stageWidth/256), (n/2)+150);
			}
			spectrum.graphics.endFill();
		}
		
	}
}
