package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.StageOrientation;
	import flash.events.StageOrientationEvent;
	import flash.system.Capabilities;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesReflow extends Sprite {
		
		private var boxTopLeft:Shape;
		private var boxTopRight:Shape;
		private var boxBottom:Shape;
		private var halfInch:Number;
		private var fullInch:Number;
		
		public function MobileAS3ExamplesReflow() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.autoOrients = true;
			
			setupBoxes();
			registerListeners();
		}
		
		
		
		protected function setupBoxes():void {
			halfInch = Capabilities.screenDPI * 0.5;
			fullInch = Capabilities.screenDPI * 1;
			
			boxTopLeft = new Shape();
			boxTopLeft.graphics.beginFill(0xFFFFFF, 1);
			boxTopLeft.x = 0;
			boxTopLeft.y = 0;
			boxTopLeft.graphics.drawRect(0, 0, halfInch, halfInch);
			boxTopLeft.graphics.endFill();
			addChild(boxTopLeft);
			
			boxTopRight = new Shape();
			boxTopRight.graphics.beginFill(0xFFFFFF, 1);
			boxTopRight.x = stage.stageWidth - halfInch;
			boxTopRight.y = 0;
			boxTopRight.graphics.drawRect(0, 0, halfInch, halfInch);
			boxTopRight.graphics.endFill();
			addChild(boxTopRight);
			
			boxBottom = new Shape();
			boxBottom.graphics.beginFill(0xFFFFFF, 1);
			boxBottom.x = 0;
			boxBottom.y = stage.stageHeight - fullInch;
			boxBottom.graphics.drawRect(0, 0, stage.stageWidth, fullInch);
			boxBottom.graphics.endFill();
			addChild(boxBottom);
		}
		
		protected function registerListeners():void {
			stage.addEventListener(StageOrientationEvent.ORIENTATION_CHANGE, onOrientationChange);
		}
		
		protected function onOrientationChange(e:StageOrientationEvent):void {
			boxTopLeft.x = 0;
			boxTopLeft.y = 0;
			boxTopRight.x = stage.stageWidth - halfInch;
			boxTopRight.y = 0;
			boxBottom.x = 0;
			boxBottom.y = stage.stageHeight - fullInch;
			boxBottom.width = stage.stageWidth;
		}
		
	}
}