package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.LocationChangeEvent;
	import flash.events.TouchEvent;
	import flash.geom.Rectangle;
	import flash.media.StageWebView;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesHistory extends Sprite {
		
		private var prevButton:Sprite;
		private var nextButton:Sprite;
		private var swv:StageWebView;
		private var swvRect:Rectangle;
		private var addressField:TextField;
		private var addressFormat:TextFormat;
		
		public function MobileAS3ExamplesHistory() {
			super();
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			setupAddressBar();
			setupPrevButton();
			setupNextButton();
			setupStageWebView();
			registerListeners();
		}
		
		protected function setupPrevButton():void {
			prevButton = new Sprite();
			prevButton.name = "prev";
			prevButton.graphics.beginFill(0xFFFFFF, 1);
			prevButton.graphics.drawRect(0, 0, 50, 50);
			prevButton.graphics.endFill();
			prevButton.x = 0;
			prevButton.y = 0;
			addChild(prevButton);
		}
		
		protected function setupNextButton():void {
			nextButton = new Sprite();
			nextButton.name = "next";
			nextButton.graphics.beginFill(0xFFFFFF, 1);
			nextButton.graphics.drawRect(0, 0, 50, 50);
			nextButton.graphics.endFill();
			nextButton.x = stage.stageWidth - 50;
			nextButton.y = 0;
			addChild(nextButton);
		}
		
		protected function setupAddressBar():void {
			addressFormat = new TextFormat;
			addressFormat.bold = true;
			addressFormat.font = "_sans";
			addressFormat.size = 26;
			addressFormat.align = "center";
			addressFormat.color = 0xFFFFFF;
			addressField = new TextField();
			addressField.defaultTextFormat = addressFormat;
			addressField.autoSize = "left";
			addressField.selectable = false;
			addressField.mouseEnabled = false;
			addressField.text = "Loading...";
			addressField.x = 60;
			addressField.y = 8;
			addChild(addressField);
		}
		
		protected function setupStageWebView():void {
			swvRect = new Rectangle(0,addressField.y+addressField.height+40,stage.stageWidth,stage.stageHeight-addressField.y+addressField.height+40);
			if(StageWebView.isSupported){
				swv = new StageWebView();
				swv.stage = this.stage;
				swv.viewPort = swvRect;
			}
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			prevButton.addEventListener(TouchEvent.TOUCH_TAP, onTouchTap);
			nextButton.addEventListener(TouchEvent.TOUCH_TAP, onTouchTap);
			swv.addEventListener(LocationChangeEvent.LOCATION_CHANGE , locationChanged);
			swv.loadURL("http://memoryspiral.com/");
		}
		
		protected function onTouchTap(e:TouchEvent):void {
			switch(e.target.name){
				case "prev":
					if(swv.isHistoryBackEnabled){
						swv.historyBack();
					}
					break;
				case "next":
					if(swv.isHistoryForwardEnabled){
						swv.historyForward();
					}
					break;
			}
		}
		
		protected function locationChanged(e:LocationChangeEvent):void {
			addressField.text = e.location;
		}
	}
	
}