package {
	import flash.data.SQLConnection;
	import flash.data.SQLStatement;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.TouchEvent;
	import flash.filesystem.File;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesDB extends Sprite {
		
		private var sqlConnection:SQLConnection;
		private var itemField:TextField;
		private var itemFormat:TextFormat;
		private var fauxButton:Sprite;
		private var buttonField:TextField;
		private var buttonFormat:TextFormat;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesDB() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupTextButton();
			setupTraceField();
			registerListeners();
			createDB();
		}
		
		protected function setupTextField():void {
			itemFormat = new TextFormat;
			itemFormat.bold = true;
			itemFormat.font = "_sans";
			itemFormat.size = 44;
			itemFormat.align = "center";
			itemFormat.color = 0x000000;
			itemField = new TextField();
			itemField.defaultTextFormat = itemFormat;
			itemField.type = "input";
			itemField.border = true;
			itemField.multiline = true;
			itemField.wordWrap = true;
			itemField.background = true;
			itemField.border = true;
			itemField.x = 20;
			itemField.y = 20;
			itemField.width = stage.stageWidth-40;
			itemField.height = 60;
			addChild(itemField);
		}
		
		protected function setupTextButton():void {
			buttonFormat = new TextFormat;
			buttonFormat.bold = true;
			buttonFormat.font = "_sans";
			buttonFormat.size = 42;
			buttonFormat.align = "center";
			buttonFormat.color = 0x333333;
			buttonField = new TextField();
			buttonField.defaultTextFormat = buttonFormat;
			buttonField.autoSize = "left";
			buttonField.selectable = false;
			buttonField.mouseEnabled = false;
			buttonField.text = "Insert to DB";
			buttonField.x = 30;
			buttonField.y = 25;
			
			fauxButton = new Sprite();
			fauxButton.addChild(buttonField);
			fauxButton.graphics.beginFill(0xFFFFFF, 1);
			fauxButton.graphics.drawRect(0, 0, buttonField.width+60, buttonField.height+50);
			fauxButton.graphics.endFill();
			fauxButton.x = (stage.stageWidth/2) - (fauxButton.width/2);
			fauxButton.y = itemField.y+itemField.height+40;
			addChild(fauxButton);
		}
		
		protected function setupTraceField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "left";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.multiline = true;
			traceField.wordWrap = true;
			traceField.mouseEnabled = false;
			traceField.x = 20;
			traceField.y = fauxButton.y+fauxButton.height+40;
			traceField.width = stage.stageWidth-40;
			traceField.height =stage.stageHeight - traceField.y;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			fauxButton.addEventListener(TouchEvent.TOUCH_TAP, insertDBItem);
		}
		
		protected function createDB():void {
			sqlConnection = new SQLConnection();
			sqlConnection.open(File.applicationStorageDirectory.resolvePath("airandroid.db"));
			var sqlStatement:SQLStatement = new SQLStatement();
			sqlStatement.sqlConnection = sqlConnection;
			sqlStatement.text = "CREATE TABLE IF NOT EXISTS items (name TEXT, time TEXT)";
			sqlStatement.execute();
			getDBItems();
		}
		protected function getDBItems():void {
			traceField.text = "";
			var sqlStatement:SQLStatement = new SQLStatement();
			sqlStatement.sqlConnection = sqlConnection;
			sqlStatement.text = "SELECT * FROM items";
			sqlStatement.execute();
			var sqlArray:Array = sqlStatement.getResult().data;
			var itemCount:int = sqlArray.length;
			for(var i:int=0; i<itemCount; i++){
				traceField.appendText("NAME: " + sqlArray[i].name + "\n");
				traceField.appendText("DATE: " + sqlArray[i].time + "\n");
				traceField.appendText("\n");
			}
		}
		protected function insertDBItem(e:TouchEvent):void {
			var date:Date = new Date();
			var sqlStatement:SQLStatement = new SQLStatement();
			sqlStatement.sqlConnection = sqlConnection;
			sqlStatement.text = "INSERT into items values(:name, :time)";
			sqlStatement.parameters[":name"] = itemField.text;
			sqlStatement.parameters[":time"] = date.toUTCString();
			sqlStatement.execute();
			getDBItems();
			itemField.text = "";
		}
		
		
	}
}