package {
	import flash.data.SQLConnection;
	import flash.data.SQLStatement;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.filesystem.File;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesDefaultDB extends Sprite {
		
		private var sqlConnection:SQLConnection;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesDefaultDB() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTraceField();
			checkDefaultDB();
		}
		
		protected function setupTraceField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "left";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.multiline = true;
			traceField.wordWrap = true;
			traceField.mouseEnabled = false;
			traceField.x = 20;
			traceField.y = 20;
			traceField.width = stage.stageWidth-40;
			traceField.height = stage.stageHeight-40;
			addChild(traceField);
		}
		
		protected function checkDefaultDB():void {
			traceField.appendText("Checking if DB exists...\n\n");
			var dbFile:File = File.applicationStorageDirectory;
			dbFile = dbFile.resolvePath("products.db");
			if(dbFile.exists){
				traceField.appendText("Application DB Okay!\n\n");
			}else{
				traceField.appendText("Application DB Missing!\n\n");
				traceField.appendText("Copying Default DB...\n\n");
				var sourceFile:File = File.applicationDirectory;
				sourceFile = sourceFile.resolvePath("default.db");
				var destination:File = File.applicationStorageDirectory;
				destination = destination.resolvePath("products.db");
				sourceFile.copyTo(destination, true);
				traceField.appendText("Database Copy Completed!\n\n");
			}
			connectDB();
		}
		
		protected function connectDB():void {
			sqlConnection = new SQLConnection();
			sqlConnection.open(File.applicationStorageDirectory.resolvePath("products.db"));
			getDBItems();
		}
		
		protected function getDBItems():void {
			traceField.appendText("Gathering items from application DB...\n\n");
			var sqlStatement:SQLStatement = new SQLStatement();
			sqlStatement.sqlConnection = sqlConnection;
			sqlStatement.text = "SELECT * FROM Products";
			sqlStatement.execute();
			var sqlArray:Array = sqlStatement.getResult().data;
			var itemCount:int = sqlArray.length;
			traceField.appendText("Database Contains:\n");
			for(var i:int=0; i<itemCount; i++){
				traceField.appendText("PRODUCT: " + sqlArray[i].ProductName + "\n");
			}
		}
		
	}
}