package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesOpenFile extends Sprite {
		
		private const path:String = "android.txt";
		private var file:File;
		private var stream:FileStream;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesOpenFile() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			beginFileOpen();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "center";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.multiline = true;
			traceField.wordWrap = true;
			traceField.mouseEnabled = false;
			traceField.x = 20;
			traceField.y = 20;
			traceField.width = stage.stageWidth-40;
			traceField.height = stage.stageHeight-40;
			addChild(traceField);
		}
		
		protected function beginFileOpen():void {
			file = new File();
			file = File.applicationDirectory;
			file = file.resolvePath(path);
			stream = new FileStream();
			stream.addEventListener(Event.COMPLETE, fileOpened);
			stream.openAsync(file, FileMode.READ);
		}
		
		protected function fileOpened(e:Event):void {
			traceField.text = stream.readMultiByte(stream.bytesAvailable, File.systemCharset);
			stream.close();
		}
		
	}
}