package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.TouchEvent;
	import flash.filesystem.File;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesSaveFile extends Sprite {
		
		private const fName:String = "airandroid.txt";
		private var file:File;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		private var fauxButton:Sprite;
		private var buttonField:TextField;
		private var buttonFormat:TextFormat;
		
		public function MobileAS3ExamplesSaveFile() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupTextButton();
			registerListeners();
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 44;
			traceFormat.align = "center";
			traceFormat.color = 0x000000;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.type = "input";
			traceField.border = true;
			traceField.multiline = true;
			traceField.wordWrap = true;
			traceField.background = true;
			traceField.border = true;
			traceField.x = 20;
			traceField.y = 20;
			traceField.width = stage.stageWidth-40;
			traceField.height = 250;
			addChild(traceField);
		}
		
		protected function setupTextButton():void {
			buttonFormat = new TextFormat;
			buttonFormat.bold = true;
			buttonFormat.font = "_sans";
			buttonFormat.size = 42;
			buttonFormat.align = "center";
			buttonFormat.color = 0x333333;
			buttonField = new TextField();
			buttonField.defaultTextFormat = buttonFormat;
			buttonField.autoSize = "left";
			buttonField.selectable = false;
			buttonField.mouseEnabled = false;
			buttonField.text = "Save as File";
			buttonField.x = 30;
			buttonField.y = 25;
			
			fauxButton = new Sprite();
			fauxButton.addChild(buttonField);
			fauxButton.graphics.beginFill(0xFFFFFF, 1);
			fauxButton.graphics.drawRect(0, 0, buttonField.width+60, buttonField.height+50);
			fauxButton.graphics.endFill();
			fauxButton.x = (stage.stageWidth/2) - (fauxButton.width/2);
			fauxButton.y = traceField.y+traceField.height+40;
			addChild(fauxButton);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			fauxButton.addEventListener(TouchEvent.TOUCH_TAP, onTouchTap);
		}
		
		protected function onTouchTap(e:TouchEvent):void {
			file = new File();
			file.addEventListener(Event.COMPLETE, fileSaved);
			file.save(traceField.text, fName);
		}
		
		protected function fileSaved(e:Event):void {
			fauxButton.removeEventListener(TouchEvent.TOUCH_TAP, onTouchTap);
			file.removeEventListener(Event.COMPLETE, fileSaved);
			traceField.text = "";
			buttonField.text = "File Saved!";
		}
		
	}
}