package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.TouchEvent;
	import flash.geom.Point;
	import flash.net.SharedObject;
	import flash.net.SharedObjectFlushStatus;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesSharedObject extends Sprite {
		
		private var airSO:SharedObject;
		private var ballPoint:Point;
		private var ball:Sprite;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesSharedObject() {
			super();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			setupTextField();
			setupBall();
			setupSharedObject();
			registerListeners();
		}
		
		protected function setupSharedObject():void {
			airSO = SharedObject.getLocal("airandroid");
			if(airSO.data.ballPoint != undefined){
				ball.x = airSO.data.ballPoint.x;
				ball.y = airSO.data.ballPoint.y;
				traceField.text = "Existing Shared Object!";
			}else{
				traceField.text = "No Shared Object Found!";
			}
		}
		
		protected function setupBall():void {
			ball = new Sprite();
			ball.graphics.beginFill(0xFFFFFF);
			ball.graphics.drawCircle(0, 0, 60);
			ball.graphics.endFill();
			ball.x = stage.stageWidth/2;
			ball.y = 260;
			addChild(ball);
		}
		
		protected function setupTextField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "center";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.multiline = true;
			traceField.wordWrap = true;
			traceField.mouseEnabled = false;
			traceField.x = 20;
			traceField.y = 20;
			traceField.width = stage.stageWidth-40;
			traceField.height = stage.stageHeight-40;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			ball.addEventListener(TouchEvent.TOUCH_MOVE, onTouchMove);
			ball.addEventListener(TouchEvent.TOUCH_END, onTouchEnd);
		}
		
		protected function onTouchMove(e:TouchEvent):void {
			ball.x = e.stageX;
			ball.y = e.stageY;
		}
		
		protected function onTouchEnd(e:Event):void {
			airSO.data.ballPoint = new Point(ball.x, ball.y);
			var flushStatus:String;
			flushStatus = airSO.flush();
			if(flushStatus != null) {
				switch(flushStatus) {
					case SharedObjectFlushStatus.FLUSHED:
						traceField.text = "Ball location x:" + ball.x + "/y:" + ball.y + " saved!";
						break;
					default:
						traceField.text = "There was a problem :(";
						break;
				}
			}
		}
		
	}
}