package {
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.system.Capabilities;
	import flash.system.System;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.getTimer;
	
	[SWF(backgroundColor="#000000", frameRate="24")]
	
	public class MobileAS3ExamplesMonitor extends Sprite {
		
		private var prevTime:Number;
		private var numFrames:Number;
		private var frameRate:Number;
		private var traceField:TextField;
		private var traceFormat:TextFormat;
		
		public function MobileAS3ExamplesMonitor() {
			super();
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			setupTraceField();
			registerListeners();
		}
		
		protected function setupTraceField():void {
			traceFormat = new TextFormat;
			traceFormat.bold = true;
			traceFormat.font = "_sans";
			traceFormat.size = 24;
			traceFormat.align = "left";
			traceFormat.color = 0xCCCCCC;
			traceField = new TextField();
			traceField.defaultTextFormat = traceFormat;
			traceField.selectable = false;
			traceField.multiline = true;
			traceField.wordWrap = true;
			traceField.mouseEnabled = false;
			traceField.x = 20;
			traceField.y = 40;
			traceField.width = stage.stageWidth-40;
			traceField.height =stage.stageHeight - traceField.y;
			addChild(traceField);
		}
		
		protected function registerListeners():void {
			prevTime = getTimer();
			numFrames = 0;
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		protected function onEnterFrame(e:Event):void {
			traceField.text = "CPU Arch: " + Capabilities.cpuArchitecture + "\n";
			traceField.appendText("Manufacturer: " + Capabilities.manufacturer + "\n");
			traceField.appendText("OS: " + Capabilities.os + "\n\n");
			traceField.appendText("Free Memory: " + System.freeMemory + "\n");
			traceField.appendText("Total Memory: " + System.totalMemory + "\n\n");
			
			numFrames++;
			var timeNow:Number = getTimer();
			var timePast:Number = timeNow - prevTime;
			
			if(timePast > 1000){
				var fpm:Number = numFrames/timePast;
				frameRate = Math.floor(fpm * 1000);
				prevTime = timeNow;
				numFrames = 0;
			}
			
			traceField.appendText("Framerate: " + frameRate);
		}
		
	}
}